// -*- C++ -*-
// $Id: features.h,v 1.1 2002/03/07 08:14:24 martin Exp $
// Medoosa test source.
//

// Initialized attribute
/** @dia:pos 32,17 */
struct InitialValue {
   static const int i = 3;
};

// Member pointers
/** @dia:pos 18,17 */
class MemberPointer {
   int i;
   int j;
   int MemberPointer::* p;
};

// Nested classes
/** @dia:pos 18,13 */
class Outer {
  /** @dia:pos 25,13 */
  class Inner {
    double pi;
  };
  char c;
  // Composition
  /** @dia:route 4,3;h,22.6784,13.7,24,13.7,25 */
  Inner i;
};

// Namespaces
namespace Empty {}
namespace Foo {
  class FooC;
  namespace Bar {
    class BarC;
    /** @dia:pos 18,22 */
    class Baz {
    public:
      int k;
      Baz();
    };
  }
}


/* illegal C++
namespace Foo::Bax {
}
*/

#if 0
// legal C++ but unimplemented in GCC
// Medoosa discards Foo::Bar
/** @dia:pos 27,22 */
class Foo::Bar::Bazz {
 public:
  int k;
  Bazz();
};
#endif

//Generalizations
/** @dia:pos 17,-6 */
class Base {
};
/** @dia:pos 19,5 */
/** @dia:route Base;v,18.5968,-3.8,-1,21.0968,5 */
class Public : public Base {
   int i;
};
/** @dia:pos 16,1 */
/** @dia:route Base;v,18.5968,-3.8,-1,18.0968,1 */
class Private : private Base {
   int j;
};
/** @dia:pos 26,5 */
/** @dia:route Base;v,18.5968,-3.8,-1,28.0968,5 */
class Virtual : virtual public Base {
   int k;
};

// Declarations
/** @dia:pos 18,26 */
class Types {
  char AProperty() const;
  void (*fun_parint_ret_ptr_to_proc_nopar(int i))(); // Ccdoc misparses this
  void (parenthesized_proc_nopar)(); // Ccdoc misparses this
  int noname(void);
  int *ptr_to_int;
  void (*ptr_to_proc_nopar)();
  double (*ptr_to_fun_pardouble_retdouble)(double arg);
  void proc_parchar_parint(char c, int i);
  void inline_proc_parchar_parint(char c, int i) {
  }
  void unnamed_params(int, float);
};


// Associations

namespace Assoc {

/* 
   Person1 and Company1:
   A company employs at least one employee, 
   a person is employed by at most four companies.
   Implemented as arrays of pointers, static and dynamic.
*/
class Company1;
class Person1 {
  Company1 *employer[4];
};
class Company1 {
  Person1 **employee;
};

/* 
   Person2 and Company2:
   A company employs at least one employee and has one boss,
   a person is employed by at most four companies 
   and is a boss to at most two companies.
   Implemented as arrays of pointers, static and dynamic.
*/
class Company2;
class Person2 {
  Company2 *employer[4];
  Company2 *bossTo[2];
};
class Company2 {
  Person2 **employee;
  Person2 *boss;
};

// ------------------------------------------------------------

/*
  File and Directory: an aggregation
  Case 1: dynamically allocated array
*/

class Directory1;
class File1 {
  // ... other members ...
  Directory1 *directory;
};
class Directory1 {
  // ... other members ...
  File1 *files;
};

// ------------------------------------------------------------

/*
  Car and Engine: unidirectional composition
*/

class Engine1 {
  void Run();
};
class Car1 {
  Engine1 engine;
};

// ------------------------------------------------------------
// pre-annotated cases

class Company2a;
/** @dia:pos -16,14 */
class Person2a {
  /** @uml:other employee */
  Company2a *employer[4];
  /** @uml:other boss */
  Company2a *bossTo[2];
};

/** @dia:pos 5,15 */
class Company2a {
  /** @uml:other employer */
  /** @dia:route 5,7;h,5,17.2,-4,16.2,-7.0493 */
  Person2a **employee;
  /** @uml:other bossTo */
  /** @dia:route 0,2;h,5,15,-3,14,-7.0493 */
  Person2a *boss;
};

/** @dia:pos -14,-8 */
class Engine1a {
  void Run();
};

/** @dia:pos 4,-7 */
class Car1a {
  /** @dia:route 0,2;h,4,-7,-3,-8,-5.1402 */
  Engine1a engine;
};

} // namespace Assoc
