<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!-- $Id: medoosa.dsl,v 1.4 2002/03/07 08:14:24 martin Exp $ -->

<!ENTITY % html "IGNORE">
<![%html;[
<!ENTITY % print "IGNORE">
<!ENTITY docbook.dsl SYSTEM "/usr/share/sgml/docbook/docbook-dsssl-stylesheets/html/docbook.dsl" CDATA dsssl>
]]>
<!ENTITY % print "INCLUDE">
<![%print;[
<!ENTITY docbook.dsl SYSTEM "/usr/share/sgml/docbook/docbook-dsssl-stylesheets/print/docbook.dsl" CDATA dsssl>
]]>
]>

<!-- Medoosa style sheet -->
<!-- Based on cygnus-both.dsl: -->
<!-- Cygnus customizations by Mark Galassi -->

<style-sheet>


<style-specification id="print" use="docbook">
<style-specification-body> 

;; ====================
;; customize the print stylesheet
;; ====================

; it was even uglier than before
; (define %titlepage-in-info-order% 
;   ;; Place elements on title page in document order?
;   #t)
;
; (define (book-titlepage-recto-elements)
;   (list (normalize "title")
;         (normalize "subtitle")
;         (normalize "graphic")
;         (normalize "mediaobject")
;         (normalize "corpauthor")
;         (normalize "affiliation")
;         (normalize "author")
;         (normalize "editor")))
;
; (define (book-titlepage-verso-elements)
;   (list (normalize "editor")
;         (normalize "edition")
;         (normalize "pubdate")
;         (normalize "copyright")
;         (normalize "abstract")
;         (normalize "legalnotice")
;         (normalize "revhistory")))

; text alignment
; DUH, rather than leaving too much blank space,
; justify makes an url fall off the page edge!
;(define %default-quadding%   
;  ;; The default quadding
;  'justify)

(define tex-backend 
  ;; Are we using the TeX backend?
  #t)

;requires tex-backend
(define bop-footnotes
  ;; Make "bottom-of-page" footnotes?
  #t)

;requires tex-backend
(define formal-object-float
  ;; Do formal objects float?
  #t)

;I rule!
(define (float-object node)
  ;; you could redefine this to make only figures float, or only tables,
  ;; or whatever...
  (if (member (gi node) (list (normalize "figure")) )
      (equal? "1" (attribute-string (normalize "float") node))
      (if (equal? (gi node) (normalize "example"))
          #f
	  #t
      )
  )
)

;aargh, changing it to A4 reflows lines in sample sources!
(define %paper-type%
  ;; Name of paper type
  ;; "A4"
  "USletter")

(define %two-side% 
  ;; Is two-sided output being produced?
  #f)

; ---

;; make funcsynopsis look pretty
(define %funcsynopsis-decoration%
  ;; Decorate elements of a FuncSynopsis?
  #t)

;; use graphics in admonitions, and have their path be "."
;; NO: we are not yet ready to use gifs in TeX and so forth
(define %admon-graphics-path%
  "./")
(define %admon-graphics%
  #f)

;; this is necessary because right now jadetex does not understand
;; symbolic entities, whereas things work well with numeric entities.
(declare-characteristic preserve-sdata?
          "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
          #f)

(define %section-autolabel% 
  ;; Are sections enumerated?
  #t)
;; (define %title-font-family% 
;;   ;; The font family used in titles
;;   "Ariel")
(define %visual-acuity%
  ;; General measure of document text size
  ;; "presbyopic"
  ;; "large-type"
  "presbyopic")

(define %generate-part-toc% #t)

;; (define %block-start-indent% 10pt)

(define %graphic-default-extension% "eps")


</style-specification-body>
</style-specification>

<!--
;; ====================
;; customize the html stylesheet
;; ====================
-->
<style-specification id="html" use="docbook">
<style-specification-body> 

;; this is necessary because right now jadetex does not understand
;; symbolic entities, whereas things work well with numeric entities.
(declare-characteristic preserve-sdata?
          "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
          #f)

;; put the legal notice in a separate file
(define %generate-legalnotice-link%
  #t)

;; use graphics in admonitions, and have their path be "stylesheet-images"
;; NO: they do not yet look very good
(define %admon-graphics-path%
  "./stylesheet-images/")
(define %admon-graphics%
  #f)

;; make funcsynopsis look pretty
(define %funcsynopsis-decoration%
  ;; Decorate elements of a FuncSynopsis?
  #t)

(define %html-ext% ".html")
(define %body-attr%
  ;; What attributes should be hung off of BODY?
  '())
;;  (list
;;   (list "BGCOLOR" "#FFFFFF")
;;   (list "TEXT" "#000000")))

(define %generate-article-toc% 
  ;; Should a Table of Contents be produced for Articles?
  ;; If true, a Table of Contents will be generated for each 'Article'.
  #t)

(define %generate-part-toc% #t)

(define %shade-verbatim%
  #t)

(define %use-id-as-filename%
  ;; Use ID attributes as name for component HTML files?
  #t)

(define %graphic-default-extension% "gif")


</style-specification-body>
</style-specification>

<external-specification id="docbook" document="docbook.dsl">

</style-sheet>
