/* $Id: debug.cc,v 1.6 2001/04/23 16:10:29 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#include "debug.h"
#include <stdio.h>

void ps(const string& s) {
  fprintf(stderr, "%s\n", s.c_str());
}

void psl(const list<string>& sl) {
  list<string>::const_iterator i;
  for (i = sl.begin(); i != sl.end(); ++i) {
    fprintf(stderr, "'%s' : ", i->c_str());
  }
}

MDebug::MDebug() {
  DisableAll();
}

void MDebug::DisableAll() {
  int i;
  for (i = 0; i <= UCHAR_MAX; ++i)
    _enabled[i] = false;
}

void MDebug::EnableAll() {
  int i;
  for (i = 0; i <= UCHAR_MAX; ++i)
    _enabled[i] = true;
}

void MDebug::Enable(const char* categories) {
  if (categories) {
    while (*categories) {
      _enabled[static_cast<unsigned char>(*categories++)] = true;
    }
  }
}

MDebug mDebug;
