/* -*- C++ -*- */
/* $Id: debug.h,v 1.8 2001/04/23 16:10:29 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_DEBUG_H
#define __M_DEBUG_H

#include <list>
#include <set>
#include <string>
#include <climits>

/** Print string */
void ps(const string& s);

/** Print string list */
void psl(const list<string>& sl);

/** Idea from Nachos, http://www.cs.washington.edu/homes/tom/nachos/ */
/** Debug categories */
enum MDebugCategories {
  DIRECTIVE = '@',
  ATTRIBUTEANDASSOCIATION = 'a',
  CLASS = 'c',
  DIFF = 'd',
  GENERALIZATION = 'g',
  PATCH ='p',
  TYPE = 't'
};

/** Helper for debugging output */
/** @dia:pos -85,7 */
class MDebug {
public:
  /** Initially, no categories are enabled */
  MDebug();
  /** Disables all categories */
  void DisableAll();
  /** Enables all categories */
  void EnableAll();
  /** Enables a set of categories specified by letters.
      @param categories May be NULL */
  void Enable(const char *categories);
  bool IsEnabled(unsigned char category) { return _enabled[category]; }
private:
  bool _enabled[UCHAR_MAX + 1];
};

/** A singleton shared debug class */
extern MDebug mDebug;

#endif
