// -*- C++ -*-
/* $Id: feature.h,v 1.7 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_FEATURE_H
#define __M_FEATURE_H

#include <list>
#include <string>
#include "common.h"
#include "type.h"
#include "element.h"

enum MScopeKind {
  INSTANCE,
  CLASSIFIER // this corresponds to C++ static members
};

/** @dia:pos -35,28 */
/** @dia:route MModelElement;v,-17.2072,17.8,20,-22.48,28 */
class MFeature : public MModelElement {
protected:
  MFeature(MNamespace *ns): MModelElement("", ns), 
    _type(ns), _ownerScope(INSTANCE) {}
  /** Extract further properties from the type.
      Only "static" and "const" for now. 
      In the future maybe virtual, inline... */
  virtual void ParseProperties(list<string> &type);

  /** @dia:route 5,11;h,-35,32.2,-37,37.9,-128.234 */
  MType _type;
  /** @dia:route 10,2;h,-35,30.9,-38,33,-67.656 */
  MVisibility _visibility;
  MScopeKind _ownerScope;
};
#endif
