// -*- C++ -*-
/* $Id: model.h,v 1.8 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_MODEL_H
#define __M_MODEL_H

#include <string>
#include <libxml/tree.h>
#include "namespace.h"

/** @dia:pos 27,7 */
class MModel {
public:
  MModel() : _isNameValid(false), _rootNs("", NULL) {}
  void LoadParseTree(xmlNodePtr cnode);
  xmlDocPtr CreateUxf();
  void LoadUxf(xmlDocPtr doc);
  void Diff(const MModel &oldModel, xmlNodePtr patchRoot);
  /** Fills in descriptions of STL containers */
  void InsertStlClassStubs();

private:
  bool _isNameValid;
  string _name;
  /** @dia:route 4,17;h,55.2512,40.7,60,12.3,54.9488 */
  /** @uml:mul 1 */
  MCxxNamespace _rootNs;
};

#endif
