// -*- C++ -*-
/* $Id: operation.h,v 1.14 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_OPERATION_H
#define __M_OPERATION_H

#include <list>
#include <string>
#include "common.h"
#include "type.h"
#include "parameter.h"
#include "feature.h"


/** @dia:pos -30,48 */
/** @dia:route MFeature;v,-22.48,32.2,43,-17.48,48 */
class MOperation : public MFeature {
public:
  MOperation(MNamespace *ns): MFeature(ns), _isQuery(false), _isAbstract(false) {}
  MModelElement *Clone() const {return new MOperation(*this);}
  void LoadParseTree(xmlNodePtr cnode);

  virtual void SaveUxf(xmlNodePtr ownerUxf, xmlNodePtr modelUxf) const;
  virtual void LoadUxf(xmlNodePtr unode);
  virtual void Diff(const MModelElement &old, xmlNodePtr patchRoot) const;
  virtual void ProcessDirectives();
protected:
  virtual void ParseProperties(list<string> &type);
private:
  bool _isQuery; //Dia does not support braced {properties}, it's a hack
  bool _isAbstract;
  /** @dia:route 23,2;h,-4.96,55.7,-1,63,-6.2336 */
  /** @uml:order ordered */
  list<MParameter> _parameters;
};

#endif
