/* $Id: parameter.cc,v 1.6 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#include "parameter.h"
#include <stdlib.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "class.h"

MParameter::MParameter(list<string>::iterator b, list<string>::iterator e, MClass *aclass)
  : _type(aclass), _class(aclass)
{
  LoadTokens(b, e);
}

void MParameter::LoadTokens(list<string>::iterator b, list<string>::iterator e)
{
  list<string> namel, type, valuel, paraml;
  _class->ParseDeclaration(b, e, namel, type, valuel, paraml);

  _name = Detokenize(namel);
  _type.Load(type);
  _defaultValue = Detokenize(valuel);
}

xmlNodePtr MParameter::SaveUxf() const
{
  xmlNodePtr uparam;
  uparam = xmlNewNode(NULL, IS_UTF8 "Parameter");  

  xmlNewChild(uparam, NULL, IS_UTF8 "Name", BAD_CAST _name.c_str());
  xmlAddChild(uparam, _type.SaveUxf(IS_UTF8 "Type"));
  if (!_defaultValue.empty())
    xmlNewChild(uparam, NULL, IS_UTF8 "DefaultValue", BAD_CAST _defaultValue.c_str());

  return uparam;
}
