// -*- C++ -*-
/* $Id: parameter.h,v 1.12 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_PARAMETER_H
#define __M_PARAMETER_H

#include <list>
#include <string>
#include "common.h"
#include "type.h"
class MClass;

/** @dia:pos -40,63 */
class MParameter {
public:
  MParameter(list<string>::iterator b, list<string>::iterator e, MClass *aclass);
  xmlNodePtr SaveUxf() const;
private:
  /** May be anonymous. */
  string _name;
  /** @dia:route 0,15;v,-40,63,59,-37,39.5,-128.234 */
  MType _type;
  string _defaultValue;
  //TODO: _kind, but neither Ccdoc nor Dia support it.
  /** @dia:route 5,7;h,3,69.6,-4,68.8,-6.2336 */
  MClass *_class;

  void LoadTokens(list<string>::iterator b, list<string>::iterator e);
};

#endif
