/* $Id: translate.cc,v 1.11 2001/04/23 16:10:30 martin Exp $ */
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#include <stdlib.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "model.h"
#include "debug.h"

int main(int argc, char **argv) {
  xmlDocPtr parseTreeDoc, modelDoc;

  if (getenv("MEDOOSA_DEBUG_ALL") != NULL)
    mDebug.EnableAll();
  else
    mDebug.Enable(getenv("MEDOOSA_DEBUG"));

  if (argc != 3) {
    fprintf(stderr, "usage: %s parse-tree.ctfx model.uxf\n", argv[0]);
    exit(1);
  }
     
  LIBXML_TEST_VERSION;
  parseTreeDoc = xmlParseFile(argv[1]);
  if (parseTreeDoc == NULL) {
    fprintf(stderr, "error parsing %s\n", argv[1]);
    exit(1);
  }
  MModel model;
  model.LoadParseTree(xmlDocGetRootElement(parseTreeDoc));
  xmlFreeDoc(parseTreeDoc);

  //rootNs.Analyze(); ?

  modelDoc = model.CreateUxf();

  int result;
  result = xmlSaveFile(argv[2], modelDoc);
  xmlFreeDoc(modelDoc);  
  return result == -1 ? 1 : 0;
}
