// -*- C++ -*-
// $Id: umltypes.h,v 1.8 2001/04/23 16:10:30 martin Exp $
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
#ifndef __M_UMLTYPES_H
#define __M_UMLTYPES_H

#include <string>
#include <libxml/tree.h>

// ---------------------------------------------------------------
// --- UML types ---

/** @dia:pos -95,52 */
class MMultiplicity {
public:
  MMultiplicity() : _isUnspecified(true), _lower(0), _upper(0) {}
  /** @param s Allowed inputs are "", "#" or "#..#" where # is an integer or "*" */
  void LoadString(const string &s);
  string SaveString() const;
  void LoadUxf(xmlNodePtr umul);
  xmlNodePtr SaveUxf() const;

  bool operator == (const MMultiplicity& b) const;
  /** Composes the two multiplicities.
   *
   * Unspecified composes with anyhing to unspecified. Otherwise,
   * each bound is a product of the respective bounds, handling
   * infinity properly
   */
  void Compose(const MMultiplicity& b);
private:
  bool _isUnspecified;
  unsigned int _lower;
  /** Infinity ("*") is represented by UINT_MAX */
  unsigned int _upper;
};

enum MAggregationKind {
  NONE,
  AGGREGATE,
  COMPOSITE
};

enum MOrderingKind {
  UNORDERED,
  ORDERED,
  SORTED
};

#endif
