#! /usr/bin/perl -w
# $Id: unflatten2.pl,v 1.2 2001/04/23 16:10:30 martin Exp $
# Medoosa: Support for Documentation of C++ Programs
# Master's Thesis, Faculty of Mathematics and Physics, Charles University
# Martin Vidner, 2001

# unflatten a .dot graph produced by uxf-g-dot.xsl

use POSIX qw(ceil);

$curchain=0;
$chainnode="";
$maxminlen=9;
$maxchain=$maxminlen;

open DOT, $ARGV[0];
while (<DOT>) {
    if (m/^(\s+")(.+)"->"(.+)".*;\s*$/) {
        ++$out{$2};
        ++$in{$3};
    }
}
close DOT;

for $k (sort keys %in) {
  print "$k: $in{$k}\n";
}

for $k (sort keys %out) {
  print "$k: $out{$k}\n";
}

#second pass
open DOT, $ARGV[0];
open UDOT, ">$ARGV[1]";

$i = 0;
while (<DOT>) {
    if (m/^(\s+")([^"]+)"(.*);\s*$/) { #"
	$node = $2;

	# chain lone nodes
	if (! $out{$node} && ! $in{$node}) {
	    print UDOT $_;
	    if ($curchain > 0) {
		print UDOT "  \"$chainnode\"->\"$node\"\[style=invis\];\n";
	    }
	    ++$curchain;
	    $chainnode = $node;
	    if ($curchain >= $maxchain) {
		$curchain = 0;
	    }	    
	}
	elsif (defined $out{$node} && $out{$node} > 2 && m/^(.*)->(.*);(.*)$/) {
	    $thismaxminlen = POSIX::ceil(sqrt($out{$node}));
	    $thismaxminlen = $maxminlen if $thismaxminlen > $maxminlen;
	    
	    $m = 1 + ($i{$node}++ % $thismaxminlen);
	    print UDOT "$1->$2\[minlen=$m\];$3\n";
	}
	else {
	    print UDOT $_;
	}
    }
    else {
	print UDOT $_;
    }
	
}
close UDOT;
close DOT;
