<?xml version="1.0"?>

<!-- $Id: uxf-g-dot.xsl,v 1.6 2002/03/22 20:57:04 martin Exp $ -->
<!--
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
-->

<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:uxf="http://www.yy.cs.keio.ac.jp/~suzuki/project/uxf/"
version="1.0">

  <xsl:output method="text"/>

  <!-- disable copying of text and attrs -->
  <xsl:template match="text()|@*"/>
   
<!-- ========================================================= -->
  <xsl:template match="/uxf:UXF/uxf:Model">
	<xsl:text>digraph "</xsl:text>
	<xsl:value-of select="uxf:Name"/>
	<xsl:text>" {
//concentrate=true;
//page="8.5,11"; 
//ratio=auto;  	
node[shape=box, URL="\N.html"];
edge[dir=back];

</xsl:text>
        <xsl:apply-templates/>
	<xsl:text>}&#10;</xsl:text>
  </xsl:template>


  <xsl:template match="uxf:Class">
	<xsl:text>  "</xsl:text>
	<xsl:value-of select="uxf:Name"/>
	<xsl:text>";&#10;</xsl:text>
  </xsl:template>

  <xsl:template match="uxf:Generalization">
	<xsl:text>  "</xsl:text>
	<xsl:value-of select="uxf:Parent"/>
	<xsl:text>"-&gt;"</xsl:text>
	<xsl:value-of select="uxf:Child"/>
	<xsl:text>" [weight=100];&#10;</xsl:text>
  </xsl:template>

  <xsl:template match="uxf:AssociationEnd[uxf:AggregationKind='CompositionWhole']">
	<xsl:text>  "</xsl:text>
        <xsl:value-of select="uxf:Type"/>
	<xsl:text>"-&gt;"</xsl:text>
        <xsl:value-of select="../uxf:AssociationEnd[uxf:AggregationKind!='CompositionWhole']/uxf:Type"/>
	<xsl:text>" [style=dotted,arrowtail=dot];&#10;</xsl:text>
  </xsl:template>

  <xsl:template match="uxf:AssociationEnd[uxf:AggregationKind='AggregationWhole']">
	<xsl:text>  "</xsl:text>
        <xsl:value-of select="uxf:Type"/>
	<xsl:text>"-&gt;"</xsl:text>
        <xsl:value-of select="../uxf:AssociationEnd[uxf:AggregationKind!='AggregationWhole']/uxf:Type"/>
	<xsl:text>" [style=dotted,arrowtail=invdot];&#10;</xsl:text>
  </xsl:template>

<!-- ========================================================= -->

<!--
-->
</xsl:stylesheet>
