<?xml version="1.0"?><!-- -*- XML -*- -->
<!-- $Id: uxf2metrics.xsl,v 1.3 2002/03/17 19:08:28 martin Exp $ -->
<!--
// Medoosa: Support for Documentation of C++ Programs
// Master's Thesis, Faculty of Mathematics and Physics, Charles University
// Martin Vidner, 2001
// Released under the terms of the GNU General Public License.
-->

<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:uxf="http://www.yy.cs.keio.ac.jp/~suzuki/project/uxf/"
version="1.0">

  <xsl:output method="html" indent="yes"/>
  <xsl:key name="classkey" match="uxf:Class" use="uxf:Name"/>

  <!-- disable copying of text and attrs -->
  <xsl:template match="text()|@*"/>
   
  <xsl:template match="/uxf:UXF/uxf:Model">
    <html>
      <title>Metrics for model <xsl:value-of select="uxf:Name"/></title>
      <style>
      <xsl:comment>
td.text {text-align: left}
td {text-align: right}
</xsl:comment>
      </style>
      <h1>Metrics for model <xsl:value-of select="uxf:Name"/></h1>

      <body bgcolor="white">
      <table border="border">
        <tr>
          <th colspan="4">Class</th>
          <th colspan="3">attributes</th>
          <th colspan="3">operations</th>
        </tr>
        <tr>
          <th>name</th>
          <th>superclasses</th>
          <th>subclasses</th>
          <th>template<br/>parameters</th>
          <th>public</th>
          <th>all</th>
          <th>% public</th>
          <th>public</th>
          <th>all</th>
          <th>% public</th>
        </tr>
	<xsl:apply-templates/>
	<xsl:call-template name='totals'/>
      </table>
      </body>
    </html>
  </xsl:template>

<!-- ========================================================= -->

  <xsl:template match="uxf:Class">
    <xsl:variable name="class-name" select="uxf:Name"/>
    <tr>
      <td class="text"><xsl:value-of select="$class-name"/></td>
      <td><xsl:value-of select="count(
			../uxf:Generalization[string(uxf:Child)=$class-name]
			)"/></td>
      <td><xsl:value-of select="count(
			../uxf:Generalization[string(uxf:Parent)=$class-name]
			)"/></td>
      <td><xsl:value-of select="count(
			uxf:TemplateParameters/uxf:Parameter
			)"/></td>

      <xsl:variable name="attr-count" select="count(uxf:Attribute)"/>
      <xsl:variable name="pub-attr-count" select="count(
		    uxf:Attribute[string(uxf:Visibility)='public']
		    )"/>
      <td><xsl:value-of select="$pub-attr-count"/></td>
      <td><xsl:value-of select="$attr-count"/></td>
      <td><xsl:value-of select="format-number($pub-attr-count div $attr-count, 
			'###%'
			)"/></td>

      <xsl:variable name="oper-count" select="count(uxf:Operation)"/>
      <xsl:variable name="pub-oper-count" select="count(
		    uxf:Operation[string(uxf:Visibility)='public']
		    )"/>
      <td><xsl:value-of select="$pub-oper-count"/></td>
      <td><xsl:value-of select="$oper-count"/></td>
      <td><xsl:value-of select="format-number($pub-oper-count div $oper-count, 
			'###%'
			)"/></td>
    </tr>
  </xsl:template>

<!-- ========================================================= -->

  <xsl:template name="totals">
    <tr>
      <td class="text">Total <xsl:value-of select="count(uxf:Class)"/></td>
      <td/>
      <td/>
      <td><xsl:value-of select="count(uxf:Class/
			uxf:TemplateParameters/uxf:Parameter
			)"/></td>

      <td><xsl:value-of select="count(uxf:Class/
			uxf:Attribute[string(uxf:Visibility)='public']
			)"/></td>
      <td><xsl:value-of select="count(uxf:Class/uxf:Attribute)"/></td>
      <td/>

      <td><xsl:value-of select="count(uxf:Class/
			uxf:Operation[string(uxf:Visibility)='public']
			)"/></td>
      <td><xsl:value-of select="count(uxf:Class/uxf:Operation)"/></td>
      <td/>
    </tr>
  </xsl:template>

<!-- ========================================================= -->

<!--
-->
</xsl:stylesheet>
